import rhinoscriptsyntax as rs

objects = rs.SelectedObjects()

if len(objects) == 0:
    objects = rs.GetObjects()

if objects:
    rs.EnableRedraw(False)
    rs.UnselectAllObjects()
    idrefToMatch = []

    for object in objects:
        if rs.ObjectType(object) == 4096:
            idref = rs.BlockInstanceName(object)
            idrefToMatch.append(idref)

    if len(idrefToMatch)>0:
        blocks = rs.ObjectsByType(4096, False, 1)
        #print len(block)
        for block in blocks:
            idref = rs.BlockInstanceName(block)
            if idref in idrefToMatch:
                rs.SelectObject(block)
    else:
        print "No block selected."
else:
    print "No object selected."